/* created 13.05.97 Joachim Schurig DL8HBS */
/* modified 19.05.97 Joachim Schurig DL8HBS */
/* modified 15.01.00 Paolo Subiaco IW3GRX */
 
/* filter for DPBOX Check- and List- lists, fills them with html links */
/* reads from stdin, writes to stdout */

/* usable only for private features :
   Syntax is : dpprivlinks -check|-list|-dir <callsign> <signature>
          or : dpprivlinks -rep|-com <callsign> <signature>
*/   


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define dpcgi "/cgi-bin/dpcmd"		//useless
#define dplist "/cgi-bin/dplist" 	//useless
#define MYBBSCALLSIGN	"IK3GET"	// bbs callsign!
// Important: you must modify the "/cgi-bin/dp.tcl" to the path of your
// main cgi script

int mode;
char call[7];	// callsign
char sign[13];	// signature (encrypted password)

int get_line(char *s)
{
  if (feof(stdin) == 0 && fgets(s, 255, stdin) != NULL) return 1;
  else return 0;
}

int put_line(char *s)
{
  fputs(s, stdout);
  return 1;
}


	
void parse_checklist(void)
/*
    1 DL8HBS &gt; DIGI.......4 12.05.97 DL8HBS 10436 181 (BIN) pastrix.Z
    2 DL8HBS &gt; DIGI.......3 26.04.97 DL8HBS  9381   1 test
*/
{
  int modified;
  int l,x;
  int num;
  char board[9], nums[5], link[80], *token;
  char s[256], o[256];
  
  while (get_line(s)) {
    modified = 0;
    *o = '\0';
    l = strlen(s);
    if (l > 55 && s[13] == '&' && s[5] == ' ' && s[12] == ' '
       && s[17] == ' ' && s[30] == ' ' && s[56] == ' ' && isdigit(s[55])
       && isdigit(s[29])) {
     
      for (x = 18; x <= 25; x++) {
        if (s[x] != '.') board[x-18] = toupper(s[x]);
        else board[x-18] = '\0';
      }
      board[8] = '\0';
     
      token = nums;
      for (x = 26; x <= 29; x++) {
        if (s[x] != '.') *token++ = s[x];
      }  
      *token = '\0';
      num = atoi(nums);
      
      if (strlen(board) > 0 && num > 0) {
        sprintf(link, "<A HREF=\"/cgi-bin/dp.tcl?c=BR&b=%s&n=%d\">",board,num);
        strncpy(o, s, 18);
        o[18] = '\0';
        strcat(o, link);
        l = strlen(o);
        strncat(o, &s[18], 12);
        o[l+12] = '\0';
        strcat(o, "</A>");
        strcat(o, &s[30]);
        modified = 1;
      }
    }
    
    if (modified) put_line(o);
    else put_line(s);
  }
}

void parse_listlist(char *type)
/*
   1 DL8HBS 01.03.97 12:26    288  test
   2 DL8HBS 26.04.97 12:22    369  test
   3 DL8HBS 26.04.97 14:46   9413  test
   4 DL8HBS 12.05.97 14:58  10468  (BIN) pastrix.Z
*/
{
  int modified;
  int l,x;
  int num;
  char board[9], nums[5], *token, *t2;
  char s[256], o[256];
  
  /* first line must be of this kind:
     Info-File: DIGI
     first word after ": " is parsed as the actual board */
  
  *board = '\0';
  t2 = board;
  if (get_line(s)) {
    token = strstr(s, ": ");
    if (token != NULL) {
      token++;token++;
      for (x = 1; x < 9; x++) {
        if (isalnum(*token) || *token == '_' || *token == '-' || *token == '/')
          *t2++ = toupper(*token++);
        else
          x = 9;
      }
      *t2 = '\0';
    }
    put_line(s);
  }  
  
  while (get_line(s)) {
    modified = 0;
    *o = '\0';
    l = strlen(s);
    if (l > 33 && s[23] == ':' && s[4] == ' ' && s[11] == ' '
       && s[20] == ' ' && s[26] == ' ' && s[33] == ' ' && isdigit(s[3])
       && isdigit(s[12])) {

      token = nums;
      for (x = 0; x <= 3; x++) {
        if (isdigit(s[x])) *token++ = s[x];
      }  
      *token = '\0';
      num = atoi(nums);
      
      if (strlen(board) > 0 && num > 0) {
        sprintf(o, "<A HREF=\"/cgi-bin/dp.tcl?c=%s&n=%d\">",type,num);
        l = strlen(o);
        strncat(o, s, 11);
        o[l+11] = '\0';
        strcat(o, "</A>");
        strcat(o, &s[11]);
        modified = 1;
      }
    }
    
    if (modified) put_line(o);
    else put_line(s);
  }
}

void parse_dirlist(void)
/*
Files:

DIGI........4 DIVERSES....1 MANUAL......6 STATISTI....2
*/
{
  int x;
  char link[80], s[256], o[256], board[9], hs[256], *t, *s1;
  
  if (get_line(s)) put_line(s);
  if (get_line(s)) put_line(s);
  
  while (get_line(s)) {
    *o = '\0';
    s1 = s;
    while (*s1 != '\0') {
      t = hs;
      x = 0;
      while (*s1 != ' ' && *s1 != '\n' && *s1 != '\r' && *s1 != '\0') {
        *t++ = *s1++;
      }
      *t = '\0';
      if (strlen(hs) > 10) {
        strncpy(board, hs, 8);
        board[9] = '\0';
        t = strchr(board, '.');
        if (t != NULL) *t = '\0';
        sprintf(link, "<A HREF=\042/cgi-bin/dp.tcl?c=listb&b=%s\042>", board);
        strcat(o, link);
        strcat(o, hs);
        strcat(o, "</A> ");
        if (*s1 != ' ') strcat(o, "\n");
      } else if (*s1 != ' ') strcat(o, "\n");
      if (*s1 != '\0') s1++;
    } 
    
    put_line(o);
  }
}


/* Extract from dpgate the correct value of DEST,@MBX,SUBJECT field and 
   write them to the STDOUT in the import format (iw3grx@ir3ip.ampr.org) */
int parse_longlist()
{ int i,j;
  char s[256], o[256];
  
  /* first line must be of this kind:
file di info: TUTTI
 Nr. From   Board    @BBS   #LT #TL RxFrom Lev Date   Bytes Pack FCT FLG T

 461 IK6ZDE TUTTI    ITA     30   0 IW3GRX   1 12.01   1209  58%   0    4 B
     Cerco Indirizzo di iw2kwv
     Flags: SFRX 

*/
  
  get_line(s);
  get_line(s);
  get_line(s);
  get_line(s);
  if (strlen(s)>75 && s[63]=='%' && (s[4]|s[11]|s[20]|s[27]|s[31]|s[35]|s[35]|s[42])==' ' 
    && isdigit(s[3]) && isdigit(s[30])) 
  {	
    sprintf(o,"%s\n%s\n",MYBBSCALLSIGN,call);
    if (mode==5)	// dest is the board name
    { for(i=strlen(o),j=12;s[j]!=' '&&j<20;i++,j++)
    	o[i]=s[j];
      o[i++]='\n';
      for(j=21;s[j]!=' '&&j<27;i++,j++)
        o[i]=s[j];
      o[i++]='\n';
    }    	
    else		// dest is the sender callsign
    { for(i=strlen(o),j=5;s[j]!=' '&&j<=10;i++,j++)
     	o[i]=s[j];
      o[i++]='\n';
      o[i++]='\n';	// leave @MBX blank!
    } 	
    for (;i<90;i++)	// fill lifetime with at least 70 spaces
      o[i]=' ';	
    o[i++]='\n';	// 5th parameter
    o[i++]='\n';	// 6th parameter
    get_line(s);	// read the subject
    if (strncasecmp(s+5,"RE:",3))
    { strcpy(o+i,"Re:");
      i+=3;
    }  
    for(j=5;s[j] && j<65;i++,j++)
      o[i]=s[j];
    o[i++]='\0';
    get_line(s);	// read the last line

    printf("%s",o);
    return 0;
  }
  else
    return 1;
}




int main(int argc, char *argv[])
{
  if (argc <= 1) mode = 1; /* check list */
  else if (!strcmp("-check", argv[1])) mode = 1;
  else if (!strcmp("-list", argv[1])) mode = 2;
  else if (!strcmp("-dir", argv[1])) mode = 3;
  else if (!strcmp("-rep",argv[1])) mode = 4;
  else if (!strcmp("-com",argv[1])) mode = 5;
  else if (!strcmp("-listb",argv[1]) &&argc==5) mode=6;
  else mode = 0;

  if (argc==4 || argc==5)
  { strncpy(call,argv[2],6);
    strncpy(sign,argv[3],12);
  }
  else
    exit(1);
    
  if (mode == 1) parse_checklist();
  else if (mode == 2) parse_listlist("PR");
  else if (mode == 3) parse_dirlist();
  else if (mode==4 || mode==5) parse_longlist();
  else if (mode==6) parse_listlist(argv[4]);
  else exit(1);
  exit(0);
}

